Index: src/hu/varadiistvan/scpl/io/BufferedStreamAcceptor.h
===================================================================
--- src/hu/varadiistvan/scpl/io/BufferedStreamAcceptor.h	(revision 27)
+++ src/hu/varadiistvan/scpl/io/BufferedStreamAcceptor.h	(revision 27)
@@ -0,0 +1,65 @@
+// Copyright (c) 2022 by István Váradi
+
+// This file is part of VSCPL, a simple cross-platform utility library
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#pragma once
+
+//------------------------------------------------------------------------------
+
+namespace hu { namespace varadiistvan { namespace scpl { namespace io {
+
+//------------------------------------------------------------------------------
+
+class BufferedStream;
+class Waiter;
+
+//------------------------------------------------------------------------------
+
+/**
+ * Interface for acceptors that accept a buffered stream
+ */
+class BufferedStreamAcceptor
+{
+public:
+    /**
+     * Get the last accepted entity as a buffered stream with the given waiter,
+     * if any.
+     */
+    virtual BufferedStream* getAcceptedBufferedStream(Waiter* waiter = nullptr) = 0;
+};
+
+//------------------------------------------------------------------------------
+
+} /* namespace hu::varadiistvan::scpl::io */ } /* namespace hu::varadiistvan::scpl */ } /* namespace hu::varadiistvan */ } /* namespace hu */
+
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/hu/varadiistvan/scpl/io/LocalAcceptor.h
===================================================================
--- src/hu/varadiistvan/scpl/io/LocalAcceptor.h	(revision 8)
+++ src/hu/varadiistvan/scpl/io/LocalAcceptor.h	(revision 27)
@@ -43,5 +43,6 @@
  * connection.
  */
-class LocalAcceptor : public FailableReference<LocalAcceptor>
+class LocalAcceptor : public FailableReference<LocalAcceptor>,
+                      public BufferedStreamAcceptor
 {
 public:
@@ -78,4 +79,9 @@
     LocalSocket* getSocket(size_t readingCapacity = LocalSocket::DEFAULT_CAPACITY,
                            size_t writingCapacity = LocalSocket::DEFAULT_CAPACITY);
+
+    /**
+     * Get the last accepted socket with the given waiter, if any.
+     */
+    BufferedStream* getAcceptedBufferedStream(Waiter* waiter = nullptr) override;
 };
 
Index: src/hu/varadiistvan/scpl/io/Makefile.am
===================================================================
--- src/hu/varadiistvan/scpl/io/Makefile.am	(revision 25)
+++ src/hu/varadiistvan/scpl/io/Makefile.am	(revision 27)
@@ -35,4 +35,5 @@
         WritingBuffer.h         \
         BufferedStream.h        \
+        BufferedStreamAcceptor.h \
         LocalConnector.h        \
         LocalClientSocket.h     \